#ifndef CONTROLCAN_H
#define CONTROLCAN_H

//ӿڿͶ
#define VCI_USBCAN1         3
#define VCI_USBCAN2         4
#define VCI_USBCAN2A        4
#define VCI_CANETUDP        12
#define VCI_CANETTCP        17
#define VCI_USBCAN_E_U      20
#define VCI_USBCAN_2E_U     21
#define VCI_USBCANFD_II     41
#define VCI_USBCANFD_I      42

//CAN
#define ERR_CAN_OVERFLOW            0x0001  //CANڲFIFO
#define ERR_CAN_ERRALARM            0x0002  //CAN󱨾
#define ERR_CAN_PASSIVE             0x0004  //CAN
#define ERR_CAN_LOSE                0x0008  //CANٲöʧ
#define ERR_CAN_BUSERR              0x0010  //CANߴ
#define ERR_CAN_BUSOFF              0x0020  //߹رմ
#define ERR_CAN_BUFFER_OVERFLOW     0x0040  //CANڲBUFFER
//ͨô루ʱĴ룩
#define ERR_DEVICEOPENED            0x0100  //豸Ѿ
#define ERR_DEVICEOPEN              0x0200  //豸
#define ERR_DEVICENOTOPEN           0x0400  //豸ûд
#define ERR_BUFFEROVERFLOW          0x0800  //
#define ERR_DEVICENOTEXIST          0x1000  //豸
#define ERR_LOADKERNELDLL           0x2000  //װض̬ʧ
#define ERR_CMDFAILED               0x4000  //ִʧܴ
#define ERR_BUFFERCREATE            0x8000  //ڴ治

//CANET
#define ERR_CANETE_PORTOPENED       0x00010000  //˿Ѿ
#define ERR_CANETE_INDEXUSED        0x00020000  //豸Ѿռ
#define ERR_REF_TYPE_ID             0x00030000  //SetReferenceGetReferenceݵRefType
#define ERR_CREATE_SOCKET           0x00030002  //Socketʧ
#define ERR_OPEN_CONNECT            0x00030003  //Socketʱʧܣ豸Ѿ
#define ERR_NO_STARTUP              0x00030004  //豸û
#define ERR_NO_CONNECTED            0x00030005  //豸
#define ERR_SEND_PARTIAL            0x00030006  //ֻ˲ֵCAN֡
#define ERR_SEND_TOO_FAST           0x00030007  //ݷ̫죬Socket

//÷״ֵ̬
#define STATUS_OK                   1
#define STATUS_ERR                  0

#define CMD_DESIP                   0
#define CMD_DESPORT                 1
#define CMD_CHGDESIPANDPORT         2
#define CMD_SRCPORT                 2
#define CMD_TCP_TYPE                4  //tcp ʽ:1 ǿͻ:0
#define TCP_CLIENT                  0
#define TCP_SERVER                  1
//ʽЧ
#define CMD_CLIENT_COUNT            5  //ϵĿͻ˼
#define CMD_CLIENT                  6  //ϵĿͻ
#define CMD_DISCONN_CLINET          7  //Ͽһ
#define CMD_SET_RECONNECT_TIME      8  //ʹԶ

//CAN֡Ͷ
#define TYPE_CAN_CLASSIC	0
#define TYPE_CAN_FD			1

typedef unsigned long       DWORD, ULONG;
typedef int                 INT;
typedef void*				HANDLE;
typedef unsigned char       BYTE;
typedef unsigned short      USHORT;
typedef char				CHAR;
typedef unsigned int        UINT;
typedef unsigned char		UCHAR;
typedef unsigned short      UINT16;
typedef void*				PVOID;

typedef struct tagRemoteClient{
    int     iIndex;
    DWORD   port;
    HANDLE  hClient;
    char    szip[32];
}REMOTE_CLIENT;

typedef struct _tagChgDesIPAndPort
{
    char    szpwd[10];
    char    szdesip[20];
    int     desport;
    BYTE    blistenonly;
}CHGDESIPANDPORT;

//1.TEGCANϵнӿڿϢ͡
typedef  struct  _VCI_BOARD_INFO{
    USHORT  hw_Version;
    USHORT  fw_Version;
    USHORT  dr_Version;
    USHORT  in_Version;
    USHORT  irq_Num;
    BYTE    can_Num;
    CHAR    str_Serial_Num[20];
    CHAR    str_hw_Type[40];
    USHORT  Reserved[4];
} VCI_BOARD_INFO,*PVCI_BOARD_INFO;

//2.CANϢ֡͡
typedef  struct  _VCI_CAN_OBJ{
    UINT    ID;
    UINT    TimeStamp;
    BYTE    TimeFlag;
    BYTE    SendType;
    BYTE    RemoteFlag;//ǷԶ֡
    BYTE    ExternFlag;//Ƿչ֡
    BYTE    DataLen;
	BYTE    Data[8];
    BYTE    Reserved[3];    //Reserved[0] 0λʾĿл߸֡
}VCI_CAN_OBJ,*PVCI_CAN_OBJ;

//2+.CANFDϢ֡͡
typedef  struct  _VCI_FD_OBJ {
	UINT    ID;
	UINT    TimeStamp;
	BYTE    TimeFlag;
	BYTE    SendType;
	BYTE    RemoteFlag;	//ǷԶ֡
	BYTE    ExternFlag;	//Ƿչ֡
	BYTE    DataLen;
	BYTE    Data[64];
	BYTE    BRS;		// ǷʹBRS
	BYTE    FDF;		// CANͶ,0ΪCAN2.O֡1ΪCANFD֡
	BYTE    Reserved[1];
}VCI_FD_OBJ, *PVCI_FD_OBJ;

//3.CAN״̬͡
typedef struct _VCI_CAN_STATUS{
    UCHAR   ErrInterrupt;
    UCHAR   regMode;
    UCHAR   regStatus;
    UCHAR   regALCapture;
    UCHAR   regECCapture; 
    UCHAR   regEWLimit;
    UCHAR   regRECounter; 
    UCHAR   regTECounter;
    DWORD   Reserved;
}VCI_CAN_STATUS,*PVCI_CAN_STATUS;

//4.Ϣ͡
typedef struct _VCI_ERR_INFO{
    UINT    ErrCode;
    BYTE    Passive_ErrData[3];
    BYTE    ArLost_ErrData;
} VCI_ERR_INFO,*PVCI_ERR_INFO;

//5.ʼCAN
typedef struct _VCI_INIT_CONFIG{
    DWORD    AccCode;
    DWORD    AccMask;
    DWORD    Reserved;
    UCHAR    Filter;
    UCHAR    Timing0;
    UCHAR    Timing1;
    UCHAR    Mode;

	//豸ΪUSBCANFD-I/II ʱʹ
	UCHAR    ChannelType;	  //CANͨͣ0ΪCAN2.0ͣ1ΪCANFD
	UCHAR    FD_Standard;    //CANFDı׼0ΪISO׼1ΪISO׼
	UCHAR	 EnBRS;			 //ǷʹBRSOBRS1ΪʹBRS.
	UCHAR    ClockMHz;	     //CAN߲ʵĻ׼ʱӣλλMHz
	DWORD	 nbtp;			 //ٲλʱ䶨
	DWORD	 dbtp;			 //λʱ䶨
	UCHAR    EnFilter;		 //Ƿʹ˲
	UCHAR    WorkMode;       //ģʽ0Ϊģʽ1Ϊֻģʽ
}VCI_INIT_CONFIG,*PVCI_INIT_CONFIG;

//6.˲
typedef struct _VCI_FILTER_RECORD{
    DWORD   ExtFrame;   //ǷΪչ֡
    DWORD   Start;
    DWORD   End;
}VCI_FILTER_RECORD,*PVCI_FILTER_RECORD;

//7.ʱԶ֡ṹ
typedef struct _VCI_AUTO_SEND_OBJ{
	BYTE    Enable;     //ʹܱ 0: 1:ʹ
	BYTE    Index;      //ı     ֧100
	DWORD   Interval;   //ʱʱ 0.1msΪλ

	union {
		VCI_CAN_OBJ objCAN;    //CAN
		VCI_FD_OBJ  objFD;     //CANFD
	}obj;
}VCI_AUTO_SEND_OBJ,*PVCI_AUTO_SEND_OBJ;

#ifdef __cplusplus
#define EXTERNC extern "C"
#define DEF(a) = a
#else
#define EXTERNC
#define DEF(a)
#endif

EXTERNC DWORD __stdcall VCI_OpenDevice(DWORD DeviceType,DWORD DeviceInd,DWORD Reserved);
EXTERNC DWORD __stdcall VCI_CloseDevice(DWORD DeviceType,DWORD DeviceInd);
EXTERNC DWORD __stdcall VCI_InitCAN(DWORD DeviceType, DWORD DeviceInd, DWORD CANInd, PVCI_INIT_CONFIG pInitConfig);

EXTERNC DWORD __stdcall VCI_ReadBoardInfo(DWORD DeviceType,DWORD DeviceInd,PVCI_BOARD_INFO pInfo);
EXTERNC DWORD __stdcall VCI_ReadErrInfo(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd,PVCI_ERR_INFO pErrInfo);
EXTERNC DWORD __stdcall VCI_ReadCANStatus(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd,PVCI_CAN_STATUS pCANStatus);

EXTERNC DWORD __stdcall VCI_GetReference(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd,DWORD RefType,PVOID pData);
EXTERNC DWORD __stdcall VCI_SetReference(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd,DWORD RefType,PVOID pData);

EXTERNC ULONG __stdcall VCI_GetReceiveNum(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd);
EXTERNC DWORD __stdcall VCI_ClearBuffer(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd);

EXTERNC DWORD __stdcall VCI_StartCAN(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd);
EXTERNC DWORD __stdcall VCI_ResetCAN(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd);

EXTERNC ULONG __stdcall VCI_Transmit(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd,PVCI_CAN_OBJ pSend,ULONG Len);
EXTERNC ULONG __stdcall VCI_Receive(DWORD DeviceType,DWORD DeviceInd,DWORD CANInd,PVCI_CAN_OBJ pReceive,ULONG Len,INT WaitTime DEF(-1));

EXTERNC ULONG __stdcall VCI_TransmitFD(DWORD DeviceType, DWORD DeviceInd, DWORD CANInd, PVCI_FD_OBJ pSend, ULONG Len);
EXTERNC ULONG __stdcall VCI_ReceiveFD(DWORD DeviceType, DWORD DeviceInd, DWORD CANInd, PVCI_FD_OBJ pReceive, ULONG Len, INT WaitTime DEF(-1));

#endif
